﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Private PreviewForm As Form
	Private mLeft,mTop,mRight,mBottom As Int
	Private pnControls As Pane
	Private pnPreview As Pane
	Private mRW As ReportWriter
	Private mDisplayPane As Pane
	Private lblPageCount As Label
	Private pnNSpinner As Pane
	Dim NS As NumberSpinner
	Private mScale, mKeepAspect As Boolean
	Private PrinterSetupCV1 As PrinterSetupCV
	Dim PageL As PageLayout
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(RW As ReportWriter,Scale As Boolean,KeepAspect As Boolean)
	mScale = Scale
	mKeepAspect =KeepAspect
	mRW = RW
	PreviewForm.Initialize("PreviewForm",733,650)
	PreviewForm.RootPane.LoadLayout("ReportWriterPreview")
	PreviewForm.Title = "Report Writer Preview"
	lblPageCount.Text = "of " & RW.PageCount
	NS.Initialize(Me,"NS",1,0,1)
	pnControls.AddNode(NS.AsNode,pnNSpinner.Left,pnNSpinner.Top,pnNSpinner.PrefWidth,pnNSpinner.PrefHeight)
	pnNSpinner.RemoveNodeFromParent
	PageL = Printer_Static.GetDefaultPrinter.GetDefaultPageLayout
	
End Sub

Public Sub ShowPage(PageNo As Int, DisplayPane As Pane)
	
	If DisplayPane Is AnchorPane Then
		Log("1")
		mDisplayPane = CloneAnchorPane(DisplayPane)
	Else
		Log("2")
		mDisplayPane = ClonePane(DisplayPane)
	End If
	NS.Value = PageNo + 1
	
	SizePage
	
End Sub

Sub SizePage
	mDisplayPane.PrefWidth = PrinterSetupCV1.Paper.GetWidth - PrinterSetupCV1.LeftMargin - PrinterSetupCV1.RightMargin
	mDisplayPane.PrefHeight = PrinterSetupCV1.Paper.GetHeight - PrinterSetupCV1.TopMargin - PrinterSetupCV1.BottomMargin
	Log("Width " & mDisplayPane.prefWidth)
	Log("Height " & mDisplayPane.PrefHeight)
	
	If PreviewForm.Visible = False Then
		PreviewForm.WindowWidth = pnControls.PrefWidth +  mDisplayPane.PrefWidth + PrinterSetupCV1.LeftMargin + PrinterSetupCV1.RightMargin + 15
		PreviewForm.WindowHeight = mDisplayPane.PrefHeight + PrinterSetupCV1.TopMargin + PrinterSetupCV1.BottomMargin + 30
		PreviewForm.RootPane.PrefWidth = mDisplayPane.PrefWidth + PrinterSetupCV1.LeftMargin + PrinterSetupCV1.RightMargin
		PreviewForm.RootPane.PrefHeight = mDisplayPane.PrefHeight + PrinterSetupCV1.TopMargin +  PrinterSetupCV1.BottomMargin
		pnPreview.RemoveAllNodes
'		pnPreview.Style = mDisplayPane.Style
		pnPreview.StyleClasses.AddAll(mDisplayPane.StyleClasses)
		pnPreview.PrefWidth = mDisplayPane.PrefWidth + PrinterSetupCV1.LeftMargin + PrinterSetupCV1.RightMargin
		pnPreview.PrefHeight = mDisplayPane.PrefHeight + PrinterSetupCV1.TopMargin +  PrinterSetupCV1.BottomMargin
		pnPreview.AddNode(mDisplayPane,PrinterSetupCV1.LeftMargin,PrinterSetupCV1.TopMargin,mDisplayPane.PrefWidth,mDisplayPane.PrefHeight)
		Log("DPW " & mDisplayPane.Width)
		Log("DPH " & mDisplayPane.Height)
		Log("PPW " & pnPreview.Width)
		Log("PPH " & pnPreview.Height)
'		CenterDispPane
		PreviewForm.ShowAndWait
	Else
		pnPreview.RemoveAllNodes
		pnPreview.PrefWidth = mDisplayPane.PrefWidth + PrinterSetupCV1.LeftMargin + PrinterSetupCV1.RightMargin
		pnPreview.PrefHeight = mDisplayPane.PrefHeight + PrinterSetupCV1.TopMargin +  PrinterSetupCV1.BottomMargin
		pnPreview.AddNode(mDisplayPane,PrinterSetupCV1.LeftMargin,PrinterSetupCV1.TopMargin,mDisplayPane.PrefWidth,mDisplayPane.PrefHeight)
		Log("PPW1 " & pnPreview.Width)
		Log("PPH1 " & pnPreview.Height)
	End If
	
End Sub

Private Sub CloneAnchorPane(P As AnchorPane) As AnchorPane
	Dim NewP As AnchorPane
	NewP.Initialize("")
	NewP.Style = P.Style
	NewP.Style = P.Style
	NewP.StyleClasses.AddAll(P.StyleClasses)
	
	For Each N As Node In AdHocWrappers.Parent_GetChildren(P)
		If N Is AnchorPane Then
			Dim AP As AnchorPane = N
			Dim NAP As AnchorPane = CloneAnchorPane(N)
			NewP.AddNode(NAP,N.Left,N.Top,AP.Width,AP.Height)
			Dim PAP As AnchorPane = N.Parent
			NewP.SetAnchors(NAP,PAP.GetLeftAnchor(N),PAP.GetTopAnchor(N),PAP.GetRightAnchor(N),PAP.GetBottomAnchor(N))
		End If
		If N Is Pane Then
			Dim Pn As Pane = N
			Dim NP As Pane = ClonePane(N)
			Log("NT " & N.Tag)
			NewP.AddNode(NP,N.Left,N.Top,Pn.Width,Pn.Height)
			Dim PAP As AnchorPane = N.Parent
			NewP.SetAnchors(NP,PAP.GetLeftAnchor(N),PAP.GetTopAnchor(N),PAP.GetRightAnchor(N),PAP.GetBottomAnchor(N))
			Log("LA " & PAP.GetLeftAnchor(N) & " : " & NewP.GetLeftAnchor(NP))
			Log("RA " & NewP.GetRightAnchor(NP))
		Else
			If N Is Label Then
				Dim L As Label = N
				NewP.AddNode(CloneLabel(N),N.Left,N.Top,L.Width,L.Height)
			Else
				If N Is ImageView Then
					Dim IV As ImageView = N
					NewP.AddNode(CloneImageView(N),N.Left,N.Top,IV.Width,IV.Height)
				End If
			End If
		End If
	Next
	NewP.PrefWidth = P.PrefWidth
	NewP.PrefHeight = P.PrefHeight
	Return NewP
End Sub

Private Sub CloneLabel(L As Label) As Label
	Dim NewL As Label
	NewL.Initialize("")
	NewL.Font = L.font
	NewL.Tag = L.Tag
	NewL.Style = L.Style
	NewL.StyleClasses.AddAll(L.StyleClasses)
	NewL.Alignment = L.Alignment
	NewL.TextColor = L.TextColor
	NewL.TextSize = L.TextSize
	NewL.WrapText = L.WrapText
	NewL.Text = L.Text
	NewL.Tag = L.Tag
	Return NewL
End Sub

Private Sub CloneImageView(IV As ImageView) As ImageView
	Dim NewIV As ImageView
	NewIV.Initialize("")
	NewIV.PreserveRatio = IV.PreserveRatio
	NewIV.SetImage(IV.GetImage)
	NewIV.Alpha = IV.Alpha
	NewIV.Style = IV.Style
	NewIV.StyleClasses.AddAll(IV.StyleClasses)
	Return NewIV
End Sub


Private Sub ClonePane(P As Pane) As Pane
	Dim NewP As Pane
	NewP.Initialize("")
	NewP.Style = P.Style
	NewP.Style = P.Style
	NewP.StyleClasses.AddAll(P.StyleClasses)
	
	For Each N As Node In AdHocWrappers.Parent_GetChildren(P)
		If N Is AnchorPane Then
			Dim AP As AnchorPane = N
			NewP.AddNode(CloneAnchorPane(N),N.Left,N.Top,AP.Width,AP.Height)
		End If
		If N Is Pane Then
			Dim Pn As Pane = N
			NewP.AddNode(ClonePane(N),N.Left,N.Top,Pn.Width,Pn.Height)
		Else
			If N Is Label Then
				Dim L As Label = N
				NewP.AddNode(CloneLabel(N),N.Left,N.Top,L.Width,L.Height)
			Else
				If N Is ImageView Then
					Dim IV As ImageView = N
					NewP.AddNode(CloneImageView(N),N.Left,N.Top,IV.Width,IV.Height)
				End If
			End If
		End If
	Next
	NewP.PrefWidth = P.PrefWidth
	NewP.PrefHeight = P.PrefHeight
	Return NewP
End Sub

Public Sub ClosePage
	PreviewForm.Close
End Sub

Private Sub CenterDispPane
	mDisplayPane.Left = (pnPreview.Width - mDisplayPane.Width) / 2
	mDisplayPane.Top = (pnPreview.Height - mDisplayPane.Height) / 2
	Log(mDisplayPane.Left & " : " & mDisplayPane.Top)
End Sub

Private Sub NS_EntryReleased(Val As Double)
	If Val < 1 Then Val = 1
	If Val > mRW.PageCount Then Val = mRW.PageCount
	mRW.PreviewShow(Val - 1)
End Sub

Sub btnDone_Action
	ClosePage
End Sub

Sub btnPrint_Action
	mRW.Print(mScale,mKeepAspect)
	ClosePage
End Sub

Sub PrinterSetupCV1_LayoutChanged
	Log("PSCV_LayoutChanged")
	SizePage
End Sub