﻿Type=Class
Version=4.2
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@

Sub Class_Globals
	Private fx As JFX
	Private PreviewForm As Form
	Private mLeft,mTop,mRight,mBottom As Int
	Private pnControls As Pane
	Private pnPreview As Pane
	Private mRW As ReportWriter
	Private mDisplayPane As AnchorPane
	Private lblPageCount As Label
	Private pnNSpinner As Pane
	Dim NS As NumberSpinner
	Private mScale, mKeepAspect As Boolean
	Private PrinterSetupCV1 As PrinterSetupCV
	Dim PageL As PageLayout
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(RW As ReportWriter,Scale As Boolean,KeepAspect As Boolean)
	mScale = Scale
	mKeepAspect =KeepAspect
	mRW = RW
	PreviewForm.Initialize("PreviewForm",733,650)
	PreviewForm.RootPane.LoadLayout("ReportWriterPreview")
	PreviewForm.Title = "Report Writer Preview"
	lblPageCount.Text = "of " & RW.PageCount
	NS.Initialize(Me,"NS",1,0,1)
	NS.Value = 1
	pnControls.AddNode(NS.AsNode,pnNSpinner.Left,pnNSpinner.Top,pnNSpinner.PrefWidth,pnNSpinner.PrefHeight)
	pnNSpinner.RemoveNodeFromParent
	PageL = Printer_Static.GetDefaultPrinter.GetDefaultPageLayout
	
End Sub

Public Sub Start
	mRW.PreviewResize(PageL.GetPrintableWidth,PageL.GetPrintableHeight)
	mRW.PreviewShowPage(NS.Value-1)
End Sub

Public Sub ShowPage(DisplayPane As AnchorPane)
	
	mDisplayPane = DisplayPane
	
	PreviewForm.WindowWidth = pnControls.PrefWidth +  mDisplayPane.Width + PrinterSetupCV1.LeftMargin + PrinterSetupCV1.RightMargin + 15
	PreviewForm.WindowHeight = mDisplayPane.Height + PrinterSetupCV1.TopMargin + PrinterSetupCV1.BottomMargin + 30
	PreviewForm.RootPane.PrefWidth = mDisplayPane.Width + PrinterSetupCV1.LeftMargin + PrinterSetupCV1.RightMargin
	PreviewForm.RootPane.PrefHeight = mDisplayPane.Height + PrinterSetupCV1.TopMargin +  PrinterSetupCV1.BottomMargin

	pnPreview.RemoveAllNodes
	pnPreview.AddNode(mDisplayPane,PrinterSetupCV1.LeftMargin,PrinterSetupCV1.TopMargin,mDisplayPane.PrefWidth,mDisplayPane.PrefHeight)
	
	If PreviewForm.Visible = False Then	PreviewForm.ShowAndWait
End Sub

Public Sub ClosePage
	PreviewForm.Close
End Sub


Private Sub NS_EntryReleased(Val As Double)
	If Val < 1 Then 
		Val = 1
		NS.Value = Val
	End If
	If Val > mRW.PageCount Then 
		Val = mRW.PageCount
		NS.Value = Val
	End If
	mRW.PreviewShowPage(Val - 1)
End Sub

Sub btnDone_Action
	ClosePage
End Sub

Sub btnPrint_Action
	mRW.Print(mScale,mKeepAspect)
	ClosePage
End Sub

Sub PrinterSetupCV1_LayoutChanged
	Log("PSCV_LayoutChanged")
	If PrinterSetupCV1.Orientation = "PORTRAIT" Then
		mRW.PreviewResize(PageL.GetPrintableWidth,PageL.GetPrintableHeight)
	Else
		mRW.PreviewResize(PageL.GetPrintableHeight,PageL.GetPrintableWidth)
	End If
	mRW.PreviewShowPage(NS.Value-1)
End Sub